/*----------------------------------------------------------------------*/
/* %full_filespec:   CommonUtils.js~4:ascii:nds#3 %                     */
/* %date_modified:   Fri May 09 14:50:49 2003 %                         */
/* %derived_by:      swright %                                          */
/*--------------------------------------------------------------------- */
/* Copyright (c) 2002, 2003 Novell, Inc.  All rights reserved.          */
/*--------------------------------------------------------------------- */

/*--------------------------------------------------------------- */
/* Write out to the given document the html for a hidden control. */
/*--------------------------------------------------------------- */
function writeHiddenControl( document, name, value )
{
	document.writeln( "<INPUT type=\"hidden\"" + " name=\"" + name + "\"" + " value=\"" + value + "\" />" );
}// end writeHiddenControl()

/*--------------------------------------------------------------- */
/* Format a la printf().                                          */
/*--------------------------------------------------------------- */
function formatString( str, arg1 )
{
	// skip the 0th argument
	for ( var i = 1; i < arguments.length; i++ )
	{
		var toReplace = "{" + eval( i - 1 ) + "}";
		var start = str.indexOf( toReplace );
		if ( start != -1 )
		{
			var before = str.substring( 0, start );
			var insert = arguments[ i ];
			var after = str.substring( start + toReplace.length, str.length );
			var str = before + insert + after;
		}
		else
		{
			break;
		}
	}
	return str;
}

/*--------------------------------------------------------------- */
/* Return a reference to an element given its name.               */
/*--------------------------------------------------------------- */
function getElementByName( elementName )
{
	var elementRef = null;
	if ( document.getElementById )
	{
		// If this is a DOM-compliant browser then use the DOM method
		elementRef = document.getElementById( elementName );
	}
	else if ( document.all )
	{
		// Otherwise, if the IE API is supported then use the all[] array
		// to find the element
		elementRef = document.all[ elementName ];
	}
	else if ( document.layers )
	{
		// Else if the Netscape API is supported then use the layers[]
		// array to get the element
		elementRef = document.layers[ elementName ];
	}
	return( elementRef );
}

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function getWindowWidth()
{
	var wndWidth	= 0;

	if ( document.layers )
	{
		wndWidth = window.innerWidth;
	}
	else if ( document.all )
	{
		wndWidth = document.body.clientWidth;
	}
	else
	{
		/* I"m not sure how Netscape 6 does this.  */
		wndWidth = window.innerWidth;
	}
	return wndWidth;
}/* end getWindowWidth() */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function centerDivHorizontally( divId )
{
	/* Get the width of the browser window.  */
	var wndWidth = getWindowWidth();

	/* Get the width of the div.  */
	var divWidth = getDivWidth( divId );

	if ( wndWidth > divWidth )
	{
		/* Calculate the new x position.  */
		var x = Math.round( ( wndWidth - divWidth ) / 2 );

		/* Get the current position of the div.  */
		var xy = getDivPosition( divId );

		/* Set the new position.  */
		setDivPosition( divId, x, xy.y );
	}
}
/* end centerDivHorizontally()  */

/*--------------------------------------------------------------- */
/* Hide the activity box, then position it in the middle of the   */
/* page on the first row.                                         */
/*--------------------------------------------------------------- */
function initializeActivityBox( divId )
{
	/* Hide the activity box. */
	showHideDiv( divId, false );
	setDivPosition( divId, 0, 10 );
}/* end initializeActivityBox() */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function showActivityBox( divId )
{
	/* Center the activity box horizontially  */
	centerDivHorizontally( divId );
	showHideDiv( divId, true );
}/* end showActivityBox()  */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function showActivityBoxWithMsg( divId, msg )
{
	/* Set the message. */
	var msgRef = getElementByName( divId + 'Msg' );
	if ( msgRef != null )
	{
		msgRef.innerHTML = msg;
	}
	showActivityBox( divId );
}/* end showActivityBox()  */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function hideActivityBox( divId )
{
	showHideDiv( divId, false );
}/* end showActivityBox()  */

/*--------------------------------------------------------------- */
/* Show/hide the div with the given id.                           */
/*--------------------------------------------------------------- */
function showHideDiv( divId, isVisible )
{
	var found = false;
	var element = null;

	if ( document.getElementById )
	{
		// If this is a DOM-compliant browser then use the DOM method
		element = document.getElementById( divId );
	}
	else if ( document.all )
	{
		// Otherwise, if the IE API is supported then use the all[] array
		// to find the element
		element = document.all[ divId ];
	}
	else if ( document.layers )
	{
		// Else if the Netscape API is supported then use the layers[]
		// array to get the element
		element = document.layers[ divId ];
	}

	if ( element )
	{
		found = true;
		if ( element.style )
		{
			element.style.visibility = "hidden";
			if ( isVisible )
			{
				element.style.visibility = "visible";
			}
		}
		else
		{
			element.visibility = "hide";
			if ( isVisible )
			{
				element.visibility = "show";
			}
		}
	}

	if ( found == false )
	{
		alert( 'In showHideDiv(), unable to find divId' );
	}
}/*  end showHideDiv()  */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function getDivWidth( divId )
{
	var found = false;
	var width = 0;

	if ( document.layers )
	{
		var layer = document.layers[ divId ];
		if ( layer )
		{
			found = true;
			width = layer.document.width;
		}
	}
	else if ( document.all )
	{
		var div = document.all[ divId ];
		if ( div )
		{
			found = true;
			width = div.offsetWidth;
		}
	}
	else
	{
		var div = document.getElementById( divId );
		if ( div != null )
		{
			found = true;
			width = div.offsetWidth;
		}
	}

	if ( found == false )
	{
		alert( 'In getDivWidth(), unable to find divId' );
	}
	return( width );
}/* end getDivWidth()  */

/*--------------------------------------------------------------- */
/*--------------------------------------------------------------- */
function getDivPosition( divId )
{
	var x = 0;
	var y = 0;
	var element = null;
	var foundInLayers = false;

	if ( document.layers )
	{
		element = document.layers[ divId ];
		foundInLayers = true;
	}
	else if ( document.all )
	{
		element = document.all[ divId ];
	}
	else
	{
		element = document.getElementById( divId );
	}

	if ( element != null )
	{
		if ( foundInLayers == true )
		{
			x = element.pageX;
			y = element.pageY;
		}
		else
		{
			x = element.offsetLeft;
			y = element.offsetTop;
		}
	}
	else
	{
		alert( 'In getPosition(), unable to find divId' );
		return( element );
	}
	return( new xyPos( x, y ) );
}/*  end getDivPosition()  */

/*--------------------------------------------------------------- */
/* Set the position of a div with the given id.                   */
/*--------------------------------------------------------------- */
function setDivPosition( divId, x, y )
{
	var found = false;
	var element = null;

	if ( document.getElementById )
	{
		// If this is a DOM-compliant browser then use the DOM method
		element = document.getElementById( divId );
	}
	else if ( document.all )
	{
		// Otherwise, if the IE API is supported then use the all[] array
		// to find the element
		element = document.all[ divId ];
	}
	else if ( document.layers )
	{
		// Else if the Netscape API is supported then use the layers[]
		// array to get the element
		element = document.layers[ divId ];
	}

	if ( element )
	{
		found = true;
		if ( element.style )
		{
			element.style.left = x + "px";
			element.style.top = y + "px";
		}
		else
		{
			element.left = x;
			element.top = y;
		}
	}

	if ( found == false )
	{
		alert( 'In setDivPosition(), unable to find divId' );
	}
}/* end setDivPosition() */

/*--------------------------------------------------------------- */
/* Constructor for the xyPos object.                              */
/*--------------------------------------------------------------- */
function xyPos( x, y )
{
	this.x = x;
	this.y = y;
}/*  end xyPos() */

/*--------------------------------------------------------------- */
/* Returns true of the object is defined, false otherwise.        */
/*--------------------------------------------------------------- */
function isObjectDefined( obj )
{
	if ( obj == null )
	{
		return false;
	}

	var sType = typeof obj;
	if ( sType != "undefined" && sType != "unknown" )
	{
		return true;
	}
	return false;
}/*  end isObjectDefined() */


/*--------------------------------------------------------------- */
/* Returns true if window.opener is valid, false otherwise.       */
/*--------------------------------------------------------------- */
function isOpenerValid()
{
	if ( isObjectDefined( window.opener ) )
	{
		var type = typeof window.opener.name;
		if ( type == "string" )
		{
			return true;
		}
	}
	return false;
}/*  end isOpenerValid() */
